# Linear congruential pseudorandom number generator
#
# Copyright (C) 2014  Patrick "P. J." McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

[ "x${_RAND_SM+set}" = 'xset' ] && return 0
_RAND_SM=1

use output
use locale

rand_x=1

srand()
{
	local x="${1}"

	case "${x}" in
		*[!0-9]*)
			warn "$(get_msg 'rand_bad_x')"
			return 1
			;;
	esac

	rand_x=${x}
}

rand()
{
	# Increment, multiplier, and modulus values are those used in glibc.
	rand_x=$((1103515245 * $rand_x + 12345))
	rand_x=$(($rand_x % 4294967296))
}
